| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLES2HardwareBufferManager Class Reference

Implementation of HardwareBufferManager for OpenGL ES. More...

`#include <OgreGLES2HardwareBufferManager.h>`

Inheritance diagram for Ogre::GLES2HardwareBufferManager:
[legend]

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }

## Public Member Functions
| GLES2HardwareBufferManager ()
virtual | ~GLES2HardwareBufferManager ()
void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies. More...
void | _notifyCounterBufferDestroyed (HardwareCounterBuffer *buf)
| Notification that at hardware counter buffer has been destroyed. More...
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed. More...
void | _notifyUniformBufferDestroyed (HardwareUniformBuffer *buf)
| Notification that at hardware uniform buffer has been destroyed. More...
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed. More...
void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. More...
HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer. More...
HardwareCounterBufferSharedPtr | createCounterBuffer (size_t sizeBytes, HardwareBuffer::Usage usage=HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE, bool useShadowBuffer=false, const String &name="")
| Create counter buffer. More...
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware vertex buffer. More...
RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()
| Create a render to vertex buffer. More...
HardwareUniformBufferSharedPtr | createUniformBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, const String &name="")
| Create uniform buffer. More...
HardwareUniformBufferSharedPtr | createUniformBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, size_t binding, const String &name="")
| Create a uniform buffer. More...
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Creates a vertex buffer. More...
VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding. More...
VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration. More...
void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding. More...
void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration. More...
GLES2StateCacheManager * | getStateCacheManager ()
void | notifyContextDestroyed (GLContext *context)
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another. More...
void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use. More...
void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse. More...

## Static Public Member Functions
static GLenum | getGLType (VertexElementType type)
| Utility function to get the correct GL type based on VET's. More...
static HardwareBufferManager & | getSingleton (void)
| Get the singleton instance. More...
static HardwareBufferManager * | getSingletonPtr (void)
| Get the singleton instance. More...

## Detailed Description

Implementation of HardwareBufferManager for OpenGL ES.

## Member Enumeration Documentation

## ◆ BufferLicenseType

enum Ogre::HardwareBufferManagerBase::BufferLicenseType
| inherited

Enumerator
BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

## Constructor & Destructor Documentation

## ◆ GLES2HardwareBufferManager()

Ogre::GLES2HardwareBufferManager::GLES2HardwareBufferManager | ( |  | ) |

## ◆ ~GLES2HardwareBufferManager()

virtual Ogre::GLES2HardwareBufferManager::~GLES2HardwareBufferManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ createVertexBuffer()

HardwareVertexBufferSharedPtr Ogre::GLES2HardwareBufferManager::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| virtual

Creates a vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

## ◆ createIndexBuffer()

HardwareIndexBufferSharedPtr Ogre::GLES2HardwareBufferManager::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| virtual

Create a hardware vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

## ◆ createRenderToVertexBuffer()

RenderToVertexBufferSharedPtr Ogre::GLES2HardwareBufferManager::createRenderToVertexBuffer | ( |  | ) |
| virtual

Create a render to vertex buffer.

Implements Ogre::HardwareBufferManagerBase.

## ◆ createUniformBuffer() [1/2]

HardwareUniformBufferSharedPtr Ogre::GLES2HardwareBufferManager::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | const String & | name = `""`
| ) |  |
| virtual

Create uniform buffer.

This type of buffer allows the upload of shader constants once, and sharing between shader stages or even shaders from another materials. The update shall be triggered by GpuProgramParameters, if is dirty

Implements Ogre::HardwareBufferManagerBase.

## ◆ createUniformBuffer() [2/2]

HardwareUniformBufferSharedPtr Ogre::GLES2HardwareBufferManager::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | size_t | binding,
|  | const String & | name = `""`
| ) |  |

Create a uniform buffer.

## ◆ createCounterBuffer()

HardwareCounterBufferSharedPtr Ogre::GLES2HardwareBufferManager::createCounterBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage = `HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE`,
|  | bool | useShadowBuffer = `false`,
|  | const String & | name = `""`
| ) |  |
| virtual

Create counter buffer.

The update shall be triggered by GpuProgramParameters, if is dirty

Implements Ogre::HardwareBufferManagerBase.

## ◆ getGLType()

static GLenum Ogre::GLES2HardwareBufferManager::getGLType | ( | VertexElementType | type | ) |
| static

Utility function to get the correct GL type based on VET's.

## ◆ getStateCacheManager()

GLES2StateCacheManager* Ogre::GLES2HardwareBufferManager::getStateCacheManager | ( |  | ) |

## ◆ notifyContextDestroyed()

void Ogre::GLES2HardwareBufferManager::notifyContextDestroyed | ( | GLContext * | context | ) |

## ◆ getSingleton()

static HardwareBufferManager& Ogre::HardwareBufferManager::getSingleton | ( | void |  | ) |
| static inherited

Get the singleton instance.

## ◆ getSingletonPtr()

static HardwareBufferManager* Ogre::HardwareBufferManager::getSingletonPtr | ( | void |  | ) |
| static inherited

Get the singleton instance.

## ◆ createVertexDeclaration()

VertexDeclaration* Ogre::HardwareBufferManagerBase::createVertexDeclaration | ( | void |  | ) |
| inherited

Creates a new vertex declaration.

## ◆ destroyVertexDeclaration()

void Ogre::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) |
| inherited

Destroys a vertex declaration.

## ◆ createVertexBufferBinding()

VertexBufferBinding* Ogre::HardwareBufferManagerBase::createVertexBufferBinding | ( | void |  | ) |
| inherited

Creates a new VertexBufferBinding.

## ◆ destroyVertexBufferBinding()

void Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) |
| inherited

Destroys a VertexBufferBinding.

## ◆ registerVertexBufferSourceAndCopy()

virtual void Ogre::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy
| ) |  |
| virtual inherited

Registers a vertex buffer as a copy of another.

Remarks
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

## ◆ allocateVertexBufferCopy()

HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false`
| ) |  |
| inherited

Allocates a copy of a given vertex buffer.

Remarks
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters

  sourceBuffer | The source buffer to use as a copy.
  licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If `true`, the current data is copied as well as the structure of the buffer/

## ◆ releaseVertexBufferCopy()

void Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| inherited

Manually release a vertex buffer copy for others to subsequently use.

Remarks
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

## ◆ touchVertexBufferCopy()

void Ogre::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| inherited

Tell engine that the vertex buffer copy intent to reuse.

Remarks
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters

  bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

## ◆ _freeUnusedBufferCopies()

void Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( | void |  | ) |
| inherited

Free all unused vertex buffer copies.

Remarks
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

## ◆ _releaseBufferCopies()

void Ogre::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) |
| inherited

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters

  forceFreeUnused | If `true`, free all unused temporary buffers. If `false`, auto detect and free all unused temporary buffers based on temporary buffers utilization.

## ◆ _forceReleaseBufferCopies() [1/2]

void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) |
| inherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

## ◆ _forceReleaseBufferCopies() [2/2]

void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) |
| inherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

## ◆ _notifyVertexBufferDestroyed()

void Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) |
| inherited

Notification that a hardware vertex buffer has been destroyed.

## ◆ _notifyIndexBufferDestroyed()

void Ogre::HardwareBufferManagerBase::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) |
| inherited

Notification that a hardware index buffer has been destroyed.

## ◆ _notifyUniformBufferDestroyed()

void Ogre::HardwareBufferManagerBase::_notifyUniformBufferDestroyed | ( | HardwareUniformBuffer * | buf | ) |
| inherited

Notification that at hardware uniform buffer has been destroyed.

## ◆ _notifyCounterBufferDestroyed()

void Ogre::HardwareBufferManagerBase::_notifyCounterBufferDestroyed | ( | HardwareCounterBuffer * | buf | ) |
| inherited

Notification that at hardware counter buffer has been destroyed.

The documentation for this class was generated from the following file:

- OgreGLES2HardwareBufferManager.h